//	y[WZbgAbvR_CAO(PageSetupDLG)̕\
//	Visual C++ 2013 32/64bit

#include <windows.h>
#include <tchar.h>
#include <math.h>
#include "resource.h"

//	EBhEvV[W[
LRESULT CALLBACK WndProc(HWND, UINT, WPARAM, LPARAM);
// Tvy[W̕\
UINT CALLBACK PagePaintHook(HWND hdlg, UINT uiMsg, WPARAM wParam, LPARAM lParam);
//	RECT͈̔͂ɋ啶`
void bigFontPaint(HDC hdc, RECT* r);

TCHAR szClassName[] = TEXT("PaseSetup");

HINSTANCE hInst;

int WINAPI _tWinMain(HINSTANCE hInstance, HINSTANCE hPreInst,TCHAR* lpszCmdLine, int nCmdShow){
	HWND hWnd;
	MSG lpMsg;
	WNDCLASS myProg;
	hInst = hInstance;

	if (!hPreInst) {
		myProg.style =CS_HREDRAW | CS_VREDRAW;
		myProg.lpfnWndProc =WndProc;
		myProg.cbClsExtra =0;
		myProg.cbWndExtra =0;
		myProg.hInstance =hInstance;
		myProg.hIcon =NULL;
		myProg.hCursor =LoadCursor(NULL, IDC_ARROW);
		myProg.hbrBackground =(HBRUSH)GetStockObject(WHITE_BRUSH);
		myProg.lpszMenuName = _TEXT("IDM_MENU");
		myProg.lpszClassName =szClassName;
		if (!RegisterClass(&myProg))
			return FALSE;
	}
	hWnd = CreateWindow(szClassName,
		szClassName,
		WS_OVERLAPPEDWINDOW,
		CW_USEDEFAULT,
		CW_USEDEFAULT,
		200,
		150,
		NULL,
		NULL,
		hInstance,
		NULL);
	ShowWindow(hWnd, nCmdShow);
	UpdateWindow(hWnd);
	while (GetMessage(&lpMsg, NULL, 0, 0)) {
		TranslateMessage(&lpMsg);
		DispatchMessage(&lpMsg);
	}
	return int(lpMsg.wParam);
}

TCHAR pName[MAX_PATH];//ݑIĂv^

//	EBhEvV[W[

LRESULT CALLBACK WndProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam){
	HDC hdc;
	PAINTSTRUCT ps;
	static int nowDPIx = 96;
	static int nowDPIy = 96;
	static UINT nowScale = 100;
	static PAGESETUPDLG psd;

	switch (msg) {
		case WM_CREATE:{
			ZeroMemory(&psd, sizeof(psd));
			psd.lStructSize = sizeof(psd);
			psd.hwndOwner = hWnd;
			psd.Flags = PSD_INHUNDREDTHSOFMILLIMETERS | PSD_ENABLEPAGEPAINTHOOK;//~Pʂɐݒ
			psd.lpfnPagePaintHook = PagePaintHook;
			DWORD size = sizeof(pName) / sizeof(pName[0]);
			GetDefaultPrinter(pName, &size);
			break;
		}
		case WM_COMMAND:
			switch (LOWORD(wParam)) {
				case IDM_QUIT:
					SendMessage(hWnd, WM_CLOSE, 0, 0L);
					break;
				case IDM_PAGESET:{
						DEVMODE* pDev = 0;
						PRINTER_DEFAULTS pdef;
						HANDLE hPrn;
						DWORD dwNeeded,dwSize;
						HGLOBAL hMem;
						if (PageSetupDlg(&psd)){	//	y[Wݒ_CAO\
							pDev = (DEVMODE*)GlobalLock(psd.hDevMode);
							if (pDev == NULL)
								return FALSE;
							_tcscpy_s(pName, sizeof(pName) / sizeof(pName[0]), pDev->dmDeviceName);
							ZeroMemory(&pdef, sizeof(pdef));
							pdef.DesiredAccess = PRINTER_ACCESS_USE;
							if (OpenPrinter(pName, &hPrn, &pdef) == 0){
								break;
							}
							GetPrinter(hPrn, 2, 0, 0, &dwNeeded);
							dwSize = dwNeeded;
							hMem = GlobalAlloc(GHND, dwSize);
							if (hMem == NULL){
								ClosePrinter(hPrn);
								break;
							}
							PRINTER_INFO_2* prnInfo=(PRINTER_INFO_2 *)GlobalLock(hMem);
							if (prnInfo == NULL){
								GlobalFree(hMem);
								ClosePrinter(hPrn);
								break;
							}
							if (GetPrinter(hPrn, 2, (LPBYTE)prnInfo, dwSize, &dwNeeded)==0){
								GlobalUnlock(hMem);
								GlobalFree(hMem);
								ClosePrinter(hPrn);
								break;
							}
							prnInfo->pDevMode->dmOrientation = pDev->dmOrientation;//p̌
							prnInfo->pDevMode->dmPaperSize = pDev->dmPaperSize;//pTCY
							prnInfo->pDevMode->dmPaperLength = pDev->dmPaperLength;//pc0.01~P
							prnInfo->pDevMode->dmPaperWidth = pDev->dmPaperWidth;//p0.01~P
							prnInfo->pDevMode->dmDefaultSource = pDev->dmDefaultSource;//\ς0
							prnInfo->pDevMode->dmPrintQuality = pDev->dmPrintQuality;//v^𑜓x
							prnInfo->pDevMode->dmColor = pDev->dmColor;//J[ / mN
							if (SetPrinter(hPrn, 2, (LPBYTE)prnInfo, 0) == 0)
								break;
							GlobalUnlock(hMem);
							GlobalFree(hMem);
							GlobalUnlock(psd.hDevMode);
							GlobalFree(psd.hDevMode);
							ClosePrinter(hPrn);
						}
					}
					break;
				case IDM_PRINT:{
					PRINTDLG pd;
					DOCINFO di;
					memset(&pd, 0, sizeof(PRINTDLG));
					pd.lStructSize = sizeof(PRINTDLG);
					pd.hwndOwner = NULL;
					pd.hDevMode = NULL;
					pd.hDevNames = NULL;
					// 	pd.Flags = foCXReLXgԂ uIvWI{^gpsɂ܂ ut@C֏óv`FbN{bNXB܂B
					pd.Flags = PD_RETURNDC |
						PD_NOPAGENUMS | PD_NOSELECTION | PD_HIDEPRINTTOFILE;
					pd.nCopies = 1;		//	1
					pd.nFromPage = 1;	//	X^[gy[W1
					pd.nToPage = 1;		//	Ō̃y[W1
					pd.nMinPage = 1;	//	y[W͈͂̍ŏl1
					pd.nMaxPage = 1;	//	y[WGfBbgRg[̍ől1
					memset(&di, 0, sizeof(DOCINFO));
					di.cbSize = sizeof(DOCINFO);
					di.lpszDocName = szClassName;//hLg
					if (PrintDlg(&pd) == TRUE) {	//	_CAO\
						StartDoc(pd.hDC, &di);
						StartPage(pd.hDC);
						RECT rect;
						DWORD offsetX1 = GetDeviceCaps(pd.hDC, PHYSICALOFFSETX); //\̈X
						DWORD offsetY1 = GetDeviceCaps(pd.hDC, PHYSICALOFFSETY); //\̈Y
						DWORD DPIx = GetDeviceCaps(pd.hDC, LOGPIXELSX);
						DWORD DPIy = GetDeviceCaps(pd.hDC, LOGPIXELSY);
						DWORD prnWidth = GetDeviceCaps(pd.hDC, HORZRES);	//	\͈͉
						DWORD prnHeight = GetDeviceCaps(pd.hDC, VERTRES);	//	\͈͏c
						DWORD paperWidth = GetDeviceCaps(pd.hDC, PHYSICALWIDTH);//	p
						DWORD paperHeight = GetDeviceCaps(pd.hDC, PHYSICALHEIGHT);//	pc
						DWORD offsetX2 = paperWidth - prnWidth - offsetX1;	// Es\
						DWORD offsetT2 = paperHeight - prnHeight - offsetY1;	// s\
						rect.left=psd.rtMargin.left* DPIx / 2540-offsetX1;
						rect.top =psd.rtMargin.top* DPIy / 2540-offsetY1;
						rect.right =paperWidth- psd.rtMargin.right*DPIx / 2540-offsetX1;
						rect.bottom =paperHeight - psd.rtMargin.bottom*DPIy / 2540-offsetY1;
						bigFontPaint(pd.hDC, &rect);
						EndPage(pd.hDC);
						EndDoc(pd.hDC);
						DeleteDC(pd.hDC);
					}
				}
			}
			break;
		case WM_CLOSE:
			DestroyWindow(hWnd);
			break;
		case WM_DESTROY:
			PostQuitMessage(0);
			break;
		case WM_PAINT:{
			hdc = BeginPaint(hWnd, &ps);
			RECT rect;
			GetClientRect(hWnd, &rect);
			bigFontPaint(hdc, &rect);
			EndPaint(hWnd, &ps);
			break;
		}
		default:
			return(DefWindowProc(hWnd, msg, wParam, lParam));
	}
	return (0L);
}

// Tvy[W̕\
UINT CALLBACK PagePaintHook(HWND hdlg, UINT uiMsg, WPARAM wParam, LPARAM lParam){
	static HDC hdc = 0;
	static RECT* rect;
	static PAGESETUPDLG* psdp = 0;
	switch (uiMsg){
	case WM_PSD_GREEKTEXTRECT:
		hdc = (HDC)wParam;
		rect = (RECT*)lParam; // 
		if (hdc && rect){
			bigFontPaint(hdc, rect);
			return TRUE;
		}
		break;
	}
	return FALSE;
}

//	RECT͈̔͂ɋ啶`
void bigFontPaint(HDC hdc, RECT* r){
	RECT& rect = *r;
	double scr = double(rect.right - rect.left) / double(rect.bottom - rect.top);
	int h = rect.bottom;
	TCHAR* str = _TEXT("MS");
	TCHAR* fontName = _TEXT("lr ");
	HFONT hFont = CreateFont(
		h, 0, 0, 0, 0, FALSE, FALSE, FALSE,
		SHIFTJIS_CHARSET, OUT_DEFAULT_PRECIS,
		CLIP_DEFAULT_PRECIS, DEFAULT_QUALITY,
		VARIABLE_PITCH, fontName
		);
	SIZE size;
	HFONT hOldFont = (HFONT)SelectObject(hdc, hFont);
	GetTextExtentPoint32(hdc, str, _tcslen(str), &size);
	double font = double(size.cx) / double(size.cy);
	if (scr < font){	//	͂ݏoĂ
		do{
			h = h*(rect.right - rect.left) / size.cx;
			SelectObject(hdc, hOldFont);
			DeleteObject(hFont);
			hFont = CreateFont(
				h, 0, 0, 0, 0, FALSE, FALSE, FALSE,
				SHIFTJIS_CHARSET, OUT_DEFAULT_PRECIS,
				CLIP_DEFAULT_PRECIS, DEFAULT_QUALITY,
				VARIABLE_PITCH, fontName
				);
			SelectObject(hdc, hFont);
			GetTextExtentPoint32(hdc, str, _tcslen(str), &size);
		} while ((rect.right - rect.left) < size.cx);
	}
	TextOut(hdc, ((rect.right - rect.left) - size.cx) / 2 + rect.left, ((rect.bottom - rect.top) - size.cy) / 2 + rect.top, str, (int)_tcslen(str));
	SelectObject(hdc, hOldFont);
	DeleteObject(hFont);
	HBRUSH hBrush = (HBRUSH)GetStockObject(NULL_BRUSH);
	HBRUSH hOldBrush = (HBRUSH)SelectObject(hdc, hBrush);
	HPEN hPen = (HPEN)GetStockObject(BLACK_PEN);
	HPEN hOldPen = (HPEN)SelectObject(hdc, hPen);
	Rectangle(hdc, r->left, r->top, r->right, r->bottom);
	SelectObject(hdc, hOldBrush);
	SelectObject(hdc, hOldPen);
}
